function [H] = formHmatrix (theta, l, L, M, n)
H= zeros(4*(n), 4*(n));
u = zeros(n, 1);
S = sin(theta);
C = cos(theta);
for k=1:(n);
    u(k) = L*(l(k))^2/(5*M);
end

% Assign Hmatrix from segment 1 to n-2
for k=1:(n-1);
    %1st Row
    H(4*k-3, 4*k-3) = 2*(l(k))^2*(S(k))^2/(6*L*l(k)) + H(4*k-3, 4*k-3);
    H(4*k-3, 4*k-2) = -2*(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-3, 4*k-2);
    H(4*k-3, 4*k-1) = 5*l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 4*k-1);
    H(4*k-3, 4*k) = 0 + H(4*k-3, 4*k);
    H(4*k-3, 4*k+1) = (l(k))^2*(S(k))^2/(6*L*l(k)) + H(4*k-3, 4*k+1);
    H(4*k-3, 4*k+2) = -(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-3, 4*k+2);
    H(4*k-3, 4*k+3) = -l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 4*k+3);
    H(4*k-3, 4*k+4) = -4*l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 4*k+4);
    %2nd Row
    H(4*k-2, 4*k-2) = 2*(l(k))^2*(C(k))^2/(6*L*l(k)) + H(4*k-2, 4*k-2);
    H(4*k-2, 4*k-1) = -5*l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4*k-1);
    H(4*k-2, 4*k) = 0 + H(4*k-2, 4*k);
    H(4*k-2, 4*k+1) = -(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4*k+1);
    H(4*k-2, 4*k+2) = (l(k))^2*(C(k))^2/(6*L*l(k)) + H(4*k-2, 4*k+2);
    H(4*k-2, 4*k+3) = l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4*k+3);
    H(4*k-2, 4*k+4) = 4*l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4*k+4);
    %3rd Row
    H(4*k-1, 4*k-1) = (14+4*u(k))/(6*L*l(k)) + H(4*k-1, 4*k-1);
    H(4*k-1, 4*k) = 0 + H(4*k-1, 4*k);
    H(4*k-1, 4*k+1) = l(k)*S(k)/(6*L*l(k)) + H(4*k-1, 4*k+1);
    H(4*k-1, 4*k+2) = -l(k)*C(k)/(6*L*l(k)) + H(4*k-1, 4*k+2);
    H(4*k-1, 4*k+3) = (2-u(k))/(6*L*l(k)) + H(4*k-1, 4*k+3);
    H(4*k-1, 4*k+4) = (-16+2*u(k))/(6*L*l(k)) + H(4*k-1, 4*k+4);
    %4th Row
    %It is always 0 add previous value
    H(4*k, 4*k) = 0 + H(4*k, 4*k);
    H(4*k, 4*k+1) = 0 + H(4*k, 4*k+1);
    H(4*k, 4*k+2) = 0 + H(4*k, 4*k+2);
    H(4*k, 4*k+3) = 0 + H(4*k, 4*k+3);
    H(4*k, 4*k+4) = 0 + H(4*k, 4*k+4);
    %5th Row
    H(4*k+1, 4*k+1) = 2*(l(k))^2*(S(k))^2/(6*L*l(k)) + H(4*k+1, 4*k+1);
    H(4*k+1, 4*k+2) = -2*(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k+1, 4*k+2);
    H(4*k+1, 4*k+3) = -5*l(k)*S(k)/(6*L*l(k)) + H(4*k+1, 4*k+3);
    H(4*k+1, 4*k+4) = 4*l(k)*S(k)/(6*L*l(k)) + H(4*k+1, 4*k+4);
    %6th Row
    H(4*k+2, 4*k+2) = 2*(l(k))^2*(C(k))^2/(6*L*l(k)) + H(4*k+2, 4*k+2);
    H(4*k+2, 4*k+3) = 5*l(k)*C(k)/(6*L*l(k)) + H(4*k+2, 4*k+3);
    H(4*k+2, 4*k+4) = -4*l(k)*C(k)/(6*L*l(k)) + H(4*k+2, 4*k+4);
    %7th Row
    H(4*k+3, 4*k+3) = (14+4*u(k))/(6*L*l(k))+ H(4*k+3, 4*k+3);
    H(4*k+3, 4*k+4) = (-16+2*u(k))/(6*L*l(k))+ H(4*k+3, 4*k+4);
    %8th Row
    H(4*k+4, 4*k+4) = (32+16*u(k))/(6*L*l(k))+ H(4*k+4, 4*k+4);
end

for k=n;
%connect last and fisrt point
    %(k-3)th Row
    H(4*k-3, 4*k-3) = 2*(l(k))^2*(S(k))^2/(6*L*l(k)) + H(4*k-3, 4*k-3);
    H(4*k-3, 4*k-2) = -2*(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-3, 4*k-2);
    H(4*k-3, 4*k-1) = 5*l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 4*k-1);
    H(4*k-3, 4*k) = 0 + H(4*k-3, 4*k);
    H(4*k-3, 1) = (l(k))^2*(S(k))^2/(6*L*l(k)) + H(4*k-3, 1);
    H(4*k-3, 2) = -(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-3, 2);
    H(4*k-3, 3) = -l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 3);
    H(4*k-3, 4) = -4*l(k)*S(k)/(6*L*l(k)) + H(4*k-3, 4);
    %(k-2)th Row
    H(4*k-2, 4*k-2) = 2*(l(k))^2*(C(k))^2/(6*L*l(k)) + H(4*k-2, 4*k-2);
    H(4*k-2, 4*k-1) = -5*l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4*k-1);
    H(4*k-2, 4*k) = 0 + H(4*k-2, 4*k);
    H(4*k-2, 1) = -(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(4*k-2, 1);
    H(4*k-2, 2) = (l(k))^2*(C(k))^2/(6*L*l(k)) + H(4*k-2, 2);
    H(4*k-2, 3) = l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 3);
    H(4*k-2, 4) = 4*l(k)*C(k)/(6*L*l(k)) + H(4*k-2, 4);
    %(k-1)th Row
    H(4*k-1, 4*k-1) = (14+4*u(k))/(6*L*l(k)) + H(4*k-1, 4*k-1);
    H(4*k-1, 4*k) = 0 + H(4*k-1, 4*k);
    H(4*k-1, 1) = l(k)*S(k)/(6*L*l(k)) + H(4*k-1, 1);
    H(4*k-1, 2) = -l(k)*C(k)/(6*L*l(k)) + H(4*k-1, 2);
    H(4*k-1, 3) = (2-u(k))/(6*L*l(k)) + H(4*k-1, 3);
    H(4*k-1, 4) = (-16+2*u(k))/(6*L*l(k)) + H(4*k-1, 4);
    %kth Row
    %It is always 0 add previous value
    H(4*k, 4*k) = 0 + H(4*k, 4*k);
    H(4*k, 1) = 0 + H(4*k, 1);
    H(4*k, 2) = 0 + H(4*k, 2);
    H(4*k, 3) = 0 + H(4*k, 3);
    H(4*k, 4) = 0 + H(4*k, 4);
    %1st Row
    H(1, 1) = 2*(l(k))^2*(S(k))^2/(6*L*l(k)) + H(1, 1);
    H(1, 2) = -2*(l(k))^2*S(k)*C(k)/(6*L*l(k)) + H(1, 2);
    H(1, 3) = -5*l(k)*S(k)/(6*L*l(k)) + H(1, 3);
    H(1, 4) = 4*l(k)*S(k)/(6*L*l(k)) + H(1, 4);
    %2nd Row
    H(2, 2) = 2*(l(k))^2*(C(k))^2/(6*L*l(k)) + H(2, 2);
    H(2, 3) = 5*l(k)*C(k)/(6*L*l(k)) + H(2, 3);
    H(2, 4) = -4*l(k)*C(k)/(6*L*l(k)) + H(2, 4);
    %3rd Row
    H(3, 3) = (14+4*u(k))/(6*L*l(k))+ H(3, 3);
    H(3, 4) = (-16+2*u(k))/(6*L*l(k))+ H(3, 4);
    %4th Row
    H(4, 4) = (32+16*u(k))/(6*L*l(k))+ H(4, 4);
end

%Half the diagnal Values
for k=1:(4*(n))
    H(k, k) = H(k, k)/2;
end

%Transpose and sum up, finish the other half of Hmatrix
H = H' + H;
